<?

function getMeterData($instanceid2) {
		$instanceid=$instanceid2+0;
		$meterkey=GetValueString(IPS_GetObjectIDByName("hash",$instanceid+0));
		$meterid=GetValueString(IPS_GetObjectIDByName("meterid",$instanceid+0));
		if((strlen($meterkey)<10)||(strlen(trim($meterid))<1)) return;
		$tsto=mktime();
		$tsfrom=$tsto-86400;
		$content=Sys_GetURLContent("https://my.discovergy.com/json?key=".$meterkey."&meterid=".$meterid."&granularity=1&from=".$tsfrom."000&to=".$tsto."000");

//		$content = preg_replace('/[^(\x20-\x7F)]*/','', $content);
//		$content=str_replace("time",'"time"',$content);
//		$content=str_replace("energy",'"energy"',$content);
//		$content=str_replace(": ",":",$content);

		$json=json_decode($content,true);

		foreach($json as $stamp) {
			if(!isset($stampfirst)) {
			      $stampfirst=$stamp;
			      $stampfirst["energy"]=substr($stamp["energy"],0,strlen($stamp["energy"])-7);
  			      $stampfirst["time"]=substr($stamp["time"],0,strlen($stamp["time"])-3);
			}
			$stamplast=$stamp;
		}
		
		$stamplast["energy"]=substr($stamplast["energy"],0,strlen($stamplast["energy"])-7);
      $stamplast["time"]=substr($stamplast["time"],0,strlen($stamplast["time"])-3);
		if($stamplast["energy"]<1) return;
		
		$avg24=($stamplast["energy"]-$stampfirst["energy"])/(86400/($stamplast["time"]-$stampfirst["time"]));
		
		$metervalue_id=IPS_GetVariableIDByName ("zaehlerstand", $instanceid);
		if($metervalue_id==FALSE) {
				$metervalue_id=IPS_CreateVariable(2);
				IPS_SetName($metervalue_id,"zaehlerstand");
				IPS_SetParent ( $metervalue_id, $instanceid );
				IPS_SetVariableCustomProfile ( $metervalue_id, "~Electricity" );
		}

		
		$avg24_id=IPS_GetVariableIDByName ("verbrauch24", $instanceid);
		if($avg24_id==FALSE) {
				$avg24_id=IPS_CreateVariable(2);
				IPS_SetName($avg24_id,"verbrauch24");
				IPS_SetParent ($avg24_id, $instanceid );
				IPS_SetVariableCustomProfile ( $avg24_id, "~Electricity" );
		}
		
      SetValueFloat($metervalue_id, $stamplast["energy"]/1000);
		SetValueFloat($avg24_id,$avg24/1000);
}

function createMeter($IPS_SELF) {
	$meterid= IPS_CreateInstance("{485D0419-BE97-4548-AA9C-C083EB82E61E}");
	IPS_SetName($meterid,"Discovergy Meter");
	IPS_SetParent($meterid,$IPS_SELF);

	$hash_id=IPS_CreateVariable(3);
	IPS_SetName($hash_id,"hash");
	IPS_SetParent($hash_id,$meterid);
	IPS_SetVariableCustomProfile ( $hash_id, "~TextBox" );
	IPS_SetVariableCustomAction ( $hash_id, $IPS_SELF );
	
	$dg_id=IPS_CreateVariable(3);
	IPS_SetName($dg_id,"meterid");
	IPS_SetParent($dg_id,$meterid);
	IPS_SetVariableCustomProfile ( $dg_id, "~TextBox" );
	IPS_SetVariableCustomAction ( $dg_id, $IPS_SELF );
	
	$eid = IPS_CreateEvent(1);
	IPS_SetName($eid,"Discovergy Abruf - ".$meterid);
	IPS_SetParent($eid,$IPS_SELF);
	IPS_SetEventCyclic($eid, 0, 0, 0, 2, 2 ,15); //Alle 15 Minuten
	IPS_SetEventActive ($eid, true);
}

if ($IPS_SENDER == "WebFront") {
   if(isset($IPS_VARIABLE)&&isset($IPS_VALUE)) {
		SetValueString($IPS_VARIABLE,$IPS_VALUE);
   }
} else
if ($IPS_SENDER == "TimerEvent") {
	$event_name=IPS_GetName ($IPS_EVENT);
	$instanceid=trim(substr($event_name,strlen("Discovergy Abruf - ")));
	getMeterData($instanceid);
} else
if($IPS_SENDER=="Execute") {
	createMeter($IPS_SELF);
}

?>
